Index: trunk/packages/vizservers/nanovis/LoadVector.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/LoadVector.cpp	(revision 1428)
+++ trunk/packages/vizservers/nanovis/LoadVector.cpp	(revision 1429)
@@ -12,37 +12,11 @@
 #include "FlowCmd.h"
 
-static INLINE char *
-skipspaces(char *string) 
+    
+
+bool
+ScaleVectorFieldData(Rappture::Outcome &context, Rappture::Unirect3d *dataPtr)
 {
-    while (isspace(*string)) {
-	string++;
-    }
-    return string;
-}
-
-static INLINE char *
-getline(char **stringPtr, char *endPtr) 
-{
-    char *line, *p;
-
-    line = skipspaces(*stringPtr);
-    for (p = line; p < endPtr; p++) {
-	if (*p == '\n') {
-	    *p++ = '\0';
-	    *stringPtr = p;
-	    return line;
-	}
-    }
-    *stringPtr = p;
-    return line;
-}
-
-bool
-SetVectorFieldData(Rappture::Outcome &context, 
-		   float xMin, float xMax, size_t xNum, 
-		   float yMin, float yMax, size_t yNum, 
-		   float zMin, float zMax, size_t zNum, 
-		   size_t nValues, float *values, Unirect3d *dataPtr)
-{
+    float *values = dataPtr->values();
+    float *nValues = dataPtr->nValues();
 #ifdef notdef
     double max_x = -1e21, min_x = 1e21;
@@ -74,5 +48,4 @@
 	    xNum, yNum, zNum, xNum * yNum * zNum);
     
-    // Generate the uniformly sampled rectangle that we need for a volume
     float *destPtr = data;
     float *srcPtr = values;
@@ -97,9 +70,5 @@
 	}
     }
-    dataPtr->xMin(xMin);
-    dataPtr->xMax(xMax);
-    dataPtr->xNum(xNum);
-    dataPtr->yMin(yMin);
-    dataPtr->yMax(yMax);
+    dataPtr->SetValues(xMin, xMax, xNum, yMin, yMax(yMax);
     dataPtr->yNum(yNum);
     dataPtr->yMin(zMin);
@@ -113,13 +82,10 @@
 
 bool
-SetResampledVectorFieldData(Rappture::Outcome &context, 
-			    float xMin, float xMax, size_t xNum, 
-			    float yMin, float yMax, size_t yNum, 
-			    float zMin, float zMax, size_t zNum, 
-			    size_t nValues, float *values, FlowCmd *flowPtr)
+ScaleResampledVectorFieldData(Rappture::Outcome &context, 
+			      Rappture::Unirect3d *dataPtr)
 {
-    Rappture::Mesh1D xgrid(xMin, xMax, xNum);
-    Rappture::Mesh1D ygrid(yMin, yMax, yNum);
-    Rappture::Mesh1D zgrid(zMin, zMax, zNum);
+    Rappture::Mesh1D xgrid(dataPtr->xMin(), dataPtr->xMax(), dataPtr->xNum());
+    Rappture::Mesh1D ygrid(dataPtr->yMin(), dataPtr->yMax(), dataPtr->yNum());
+    Rappture::Mesh1D zgrid(dataPtr->zMin(), dataPtr->zMax(), dataPtr->zNum());
     Rappture::FieldRect3D xfield(xgrid, ygrid, zgrid);
     Rappture::FieldRect3D yfield(xgrid, ygrid, zgrid);
@@ -135,10 +101,10 @@
     max_mag = -1e21, nzero_min = min_mag = 1e21;
     size_t i, j;
-    for (i = j = 0; i < nValues; i += 3, j++) {
+    for (i = j = 0; i < dataPtr->nValues(); i += 3, j++) {
 	double vx, vy, vz, vm;
 
-	vx = values[i];
-	vy = values[i+1];
-	vz = values[i+2];
+	vx = dataPtr->values[i];
+	vy = dataPtr->values[i+1];
+	vz = dataPtr->values[i+2];
 	
 	xfield.define(j, vx);
@@ -217,5 +183,5 @@
 	}
     }
-    
+    dataPtr->zMin()
     flowPtr->xMin = xMin;
     flowPtr->xMax = xMax;
@@ -246,5 +212,4 @@
 
 
-#ifdef notdef
 /*
  * Load a 3D vector field from a dx-format file
@@ -371,3 +336,2 @@
 }
 
-#endif
Index: trunk/packages/vizservers/nanovis/NvFlowVisRenderer.h
===================================================================
--- trunk/packages/vizservers/nanovis/NvFlowVisRenderer.h	(revision 1428)
+++ trunk/packages/vizservers/nanovis/NvFlowVisRenderer.h	(revision 1429)
@@ -44,4 +44,7 @@
 	void reset();
 	void render();
+
+	void addVectorField(Volume* volPtr, const Vector3& ori, float scaleX, 
+		float scaleY, float scaleZ, float max);
 
 	void addVectorField(const std::string& vfName, Volume* volPtr, const Vector3& ori, float scaleX, float scaleY, float scaleZ, float max);
Index: trunk/packages/vizservers/nanovis/NvLIC.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/NvLIC.cpp	(revision 1428)
+++ trunk/packages/vizservers/nanovis/NvLIC.cpp	(revision 1429)
@@ -308,4 +308,5 @@
     float x1, x2, y, px, py;
     
+    glPushMatrix();
     glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbo);
     
@@ -313,4 +314,6 @@
     glLoadIdentity(); 
     glPushAttrib(GL_VIEWPORT_BIT | GL_ENABLE_BIT);
+
+    /*glPushMatrix();*/
     glViewport(0, 0, (GLsizei) NPIX, (GLsizei) NPIX);
     //glTranslatef(-1.0, -1.0, 0.0); 
@@ -397,5 +400,5 @@
     glPopMatrix();
     glMatrixMode(GL_PROJECTION);
-    glPopMatrix();
+    /*glPopMatrix();*/
     glMatrixMode(GL_MODELVIEW);
 }
@@ -488,6 +491,6 @@
 
 void 
-NvLIC::setVectorField(unsigned int texID, const Vector3& ori, float scaleX, float scaleY, 
-                      float scaleZ, float max)
+NvLIC::setVectorField(unsigned int texID, const Vector3& ori, 
+		      float scaleX, float scaleY, float scaleZ, float max)
 {
     Trace("NvLIC: vector field is assigned [%d]\n", texID);
@@ -531,12 +534,10 @@
 NvLIC::set_offset(float v)
 {
-	switch (axis)
-	{
-	case 0 : offset.x = v; break;
-	case 1 : offset.y = v; break;
-	case 2 : offset.z = v; break;
-	}
-
-	get_slice();
+    switch (axis) {
+    case 0 : offset.x = v; break;
+    case 1 : offset.y = v; break;
+    case 2 : offset.z = v; break;
+    }
+    get_slice();
 }
 
Index: trunk/packages/vizservers/nanovis/NvParticleRenderer.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/NvParticleRenderer.cpp	(revision 1428)
+++ trunk/packages/vizservers/nanovis/NvParticleRenderer.cpp	(revision 1429)
@@ -25,5 +25,4 @@
 #include <stdlib.h>
 
-
 #define NV_32
 
@@ -51,5 +50,5 @@
     m_vertex_array = new RenderVertexArray(psys_width*psys_height, 3, GL_FLOAT);
 
-    assert(glGetError()==0);
+    assert(CheckGL(AT));
 
     glGenFramebuffersEXT(2, psys_fbo);
@@ -131,4 +130,6 @@
     glDeleteFramebuffersEXT(2, psys_fbo);
 
+    delete m_vertex_array;
+    delete _advectionShader;
     free(data);
 }
@@ -244,5 +245,5 @@
     if (reborn) 
         reset();
-
+    
     glDisable(GL_BLEND);
     glDisable(GL_DEPTH_TEST);
Index: trunk/packages/vizservers/nanovis/Switch.h
===================================================================
--- trunk/packages/vizservers/nanovis/Switch.h	(revision 1428)
+++ trunk/packages/vizservers/nanovis/Switch.h	(revision 1429)
@@ -34,10 +34,4 @@
 #  include <stddef.h>
 #endif /* HAVE_STDDEF_H */
-
-#ifdef offsetof
-#define SwitchOffset(type, field) ((int) offsetof(type, field))
-#else
-#define SwitchOffset(type, field) ((int) ((char *) &((type *) 0)->field))
-#endif
 
 namespace Rappture {
Index: trunk/packages/vizservers/nanovis/Trace.h
===================================================================
--- trunk/packages/vizservers/nanovis/Trace.h	(revision 1428)
+++ trunk/packages/vizservers/nanovis/Trace.h	(revision 1429)
@@ -5,4 +5,8 @@
 #include <GL/glut.h>
 
+#define MAKE_STRING(x) #x
+#define NEWSTRING(x) MAKE_STRING(x)
+#define AT __FILE__ ":" NEWSTRING(__LINE__)
+
 extern void Trace(const char* format, ...);
 extern bool CheckFBO(GLenum *statusPtr);
Index: trunk/packages/vizservers/nanovis/Unirect.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/Unirect.cpp	(revision 1428)
+++ trunk/packages/vizservers/nanovis/Unirect.cpp	(revision 1429)
@@ -1,9 +1,38 @@
 
+#include <float.h>
 #include <tcl.h>
 #include <Unirect.h>
+#include "RpField1D.h"
+#include "RpFieldRect3D.h"
 
 extern int GetFloatFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr, 
 	float *valuePtr);
 extern int GetAxisFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr, int *indexPtr);
+
+static INLINE char *
+skipspaces(char *string) 
+{
+    while (isspace(*string)) {
+	string++;
+    }
+    return string;
+}
+
+static INLINE char *
+getline(char **stringPtr, char *endPtr) 
+{
+    char *line, *p;
+
+    line = skipspaces(*stringPtr);
+    for (p = line; p < endPtr; p++) {
+	if (*p == '\n') {
+	    *p++ = '\0';
+	    *stringPtr = p;
+	    return line;
+	}
+    }
+    *stringPtr = p;
+    return line;
+}
 
 int 
@@ -30,5 +59,4 @@
     axis3 = 0;			/* X-axis */
 
-    int extents = 1;
     values = NULL;
     num[0] = num[1] = num[2] = nValues = 0;
@@ -115,5 +143,5 @@
 	    }
         } else if ((c == 'u') && (strcmp(string, "units") == 0)) {
-            vUnits_ = strdup(Tcl_GetString(objv[i+1]));
+            _vUnits = strdup(Tcl_GetString(objv[i+1]));
         } else if ((c == 'o') && (strcmp(string, "order") == 0)) {
 	    Tcl_Obj **axes;
@@ -142,5 +170,5 @@
         return TCL_ERROR;
     }
-    if (nValues != (num[0] * num[1] * num[2] * extents)) {
+    if ((size_t)nValues != (num[0] * num[1] * num[2] * _nComponents)) {
         Tcl_AppendResult(interp, 
 		"wrong number of values: must be xnum*ynum*znum*extents", 
@@ -149,7 +177,4 @@
     }
     
-    fprintf(stderr, "generating %dx%dx%dx%d = %d points\n", 
-	    num[0], num[1], num[2], extents, num[0]*num[1]*num[2]*extents);
-
     if ((axis1 != 2) || (axis2 != 1) || (axis3 != 0)) {
 	// Reorder the data into x, y, z where x varies fastest and so on.
@@ -165,12 +190,12 @@
 
 		for (x = 0; x < num[2]; x++) {
-		    int i, v;
+		    int i;
 		    
 		    /* Compute the index from the data's described ordering. */
 		    i = ((z*num[axis2]*num[axis3]) + (y*num[axis3]) + x) * 3;
-		    for(v = 0; v < extents; v++) {
+		    for(size_t v = 0; v < _nComponents; v++) {
 			dp[v] = values[i+v];
 		    }
-		    dp += extents;
+		    dp += _nComponents;
 		}
 	    }
@@ -180,29 +205,28 @@
     }
 
-    values_ = values;
-    nValues_ = nValues;
-    extents_ = extents;
+    _values = values;
+    _nValues = nValues;
     if (units[3] != NULL) {
-	vUnits_ = strdup(units[3]);
-    }
-    xMin_ = min[axis3];
-    xMax_ = max[axis3];
-    xNum_ = num[axis3];
+	_vUnits = strdup(units[3]);
+    }
+    _xMin = min[axis3];
+    _xMax = max[axis3];
+    _xNum = num[axis3];
     if (units[axis3] != NULL) {
-	xUnits_ = strdup(units[axis3]);
-    }
-    yMin_ = min[axis2];
-    yMax_ = max[axis2];
-    yNum_ = num[axis2];
+	_xUnits = strdup(units[axis3]);
+    }
+    _yMin = min[axis2];
+    _yMax = max[axis2];
+    _yNum = num[axis2];
     if (units[axis2] != NULL) {
-	yUnits_ = strdup(units[axis2]);
-    }
-    zMin_ = min[axis1];
-    zMax_ = max[axis1];
-    zNum_ = num[axis1];
+	_yUnits = strdup(units[axis2]);
+    }
+    _zMin = min[axis1];
+    _zMax = max[axis1];
+    _zNum = num[axis1];
     if (units[axis1] != NULL) {
-	zUnits_ = strdup(units[axis1]);
-    }
-    initialized_ = true;
+	_zUnits = strdup(units[axis1]);
+    }
+    _initialized = true;
     return TCL_OK;
 }
@@ -225,21 +249,20 @@
     axis[1] = 0;			/* Y-axis */
 
-    extents_ = 1;
-    xNum_ = yNum_ = nValues_ = 0;
-    xMin_ = yMin_ = xMax_ = yMax_ = 0.0f;
-    if (xUnits_ != NULL) {
-	free(xUnits_);
-    }
-    if (yUnits_ != NULL) {
-	free(yUnits_);
-    }
-    if (vUnits_ != NULL) {
-	free(vUnits_);
-    }
-    xUnits_ = yUnits_ = vUnits_ = NULL;
-    if (values_ != NULL) {
-	delete [] values_;
-    }
-    values_ = NULL;
+    _xNum = _yNum = _nValues = 0;
+    _xMin = _yMin = _xMax = _yMax = 0.0f;
+    if (_xUnits != NULL) {
+	free(_xUnits);
+    }
+    if (_yUnits != NULL) {
+	free(_yUnits);
+    }
+    if (_vUnits != NULL) {
+	free(_vUnits);
+    }
+    _xUnits = _yUnits = _vUnits = NULL;
+    if (_values != NULL) {
+	delete [] _values;
+    }
+    _values = NULL;
 
     int i;
@@ -251,9 +274,9 @@
         c = string[0];
         if ((c == 'x') && (strcmp(string, "xmin") == 0)) {
-            if (GetFloatFromObj(interp, objv[i+1], &xMin_) != TCL_OK) {
+            if (GetFloatFromObj(interp, objv[i+1], &_xMin) != TCL_OK) {
                 return TCL_ERROR;
             }
         } else if ((c == 'x') && (strcmp(string, "xmax") == 0)) {
-            if (GetFloatFromObj(interp, objv[i+1], &xMax_) != TCL_OK) {
+            if (GetFloatFromObj(interp, objv[i+1], &_xMax) != TCL_OK) {
                 return TCL_ERROR;
             }
@@ -268,13 +291,13 @@
                 return TCL_ERROR;
             }
-	    xNum_ = n;
+	    _xNum = n;
         } else if ((c == 'x') && (strcmp(string, "xunits") == 0)) {
-            xUnits_ = strdup(Tcl_GetString(objv[i+1]));
+            _xUnits = strdup(Tcl_GetString(objv[i+1]));
         } else if ((c == 'y') && (strcmp(string, "ymin") == 0)) {
-            if (GetFloatFromObj(interp, objv[i+1], &yMin_) != TCL_OK) {
+            if (GetFloatFromObj(interp, objv[i+1], &_yMin) != TCL_OK) {
                 return TCL_ERROR;
             }
         } else if ((c == 'y') && (strcmp(string, "ymax") == 0)) {
-            if (GetFloatFromObj(interp, objv[i+1], &yMax_) != TCL_OK) {
+            if (GetFloatFromObj(interp, objv[i+1], &_yMax) != TCL_OK) {
                 return TCL_ERROR;
             }
@@ -289,7 +312,7 @@
                 return TCL_ERROR;
             }
-	    yNum_ = n;
+	    _yNum = n;
         } else if ((c == 'y') && (strcmp(string, "yunits") == 0)) {
-            yUnits_ = strdup(Tcl_GetString(objv[i+1]));
+            _yUnits = strdup(Tcl_GetString(objv[i+1]));
         } else if ((c == 'v') && (strcmp(string, "values") == 0)) {
             Tcl_Obj **vobj;
@@ -304,14 +327,14 @@
                 return TCL_ERROR;
 	    }
-	    nValues_ = n;
-            values_ = new float[nValues_];
+	    _nValues = n;
+            _values = new float[_nValues];
             size_t j;
-            for (j = 0; j < nValues_; j++) {
-                if (GetFloatFromObj(interp, vobj[j], values_ + j)!=TCL_OK) {
+            for (j = 0; j < _nValues; j++) {
+                if (GetFloatFromObj(interp, vobj[j], _values + j)!=TCL_OK) {
                     return TCL_ERROR;
 		}
 	    }
         } else if ((c == 'u') && (strcmp(string, "units") == 0)) {
-            vUnits_ = strdup(Tcl_GetString(objv[i+1]));
+            _vUnits = strdup(Tcl_GetString(objv[i+1]));
         } else if ((c == 'e') && (strcmp(string, "extents") == 0)) {
 	    int n;
@@ -325,5 +348,5 @@
                 return TCL_ERROR;
             }
-	    extents_ = n;
+	    _nComponents = n;
         } else if ((c == 'a') && (strcmp(string, "axisorder") == 0)) {
 	    Tcl_Obj **order;
@@ -350,9 +373,9 @@
         }
     }
-    if (values_ == NULL) {
+    if (_values == NULL) {
         Tcl_AppendResult(interp, "missing \"values\" key", (char *)NULL);
         return TCL_ERROR;
     }
-    if (nValues_ != (xNum_ * yNum_ * extents_)) {
+    if (_nValues != (_xNum * _yNum * _nComponents)) {
         Tcl_AppendResult(interp, 
 		"wrong number of values: must be xnum*ynum*extents", 
@@ -361,7 +384,4 @@
     }
     
-    fprintf(stderr, "generating %dx%dx%d = %d points\n", 
-	    xNum_, yNum_, extents_, xNum_ * yNum_ * extents_);
-
 #ifndef notdef
     if ((axis[0] != 1) || (axis[1] != 0)) {
@@ -371,24 +391,232 @@
 	float *data, *dp;
 
-	dp = data = new float[nValues_];
-	for (y = 0; y < yNum_; y++) {
+	dp = data = new float[_nValues];
+	for (y = 0; y < _yNum; y++) {
 	    size_t x;
 
-	    for (x = 0; x < xNum_; x++) {
+	    for (x = 0; x < _xNum; x++) {
 		size_t i, v;
 		    
 		/* Compute the index from the data's described ordering. */
-		i = (y + (yNum_ * x)) * extents_;
-		for(v = 0; v < extents_; v++) {
-		    dp[v] = values_[i+v];
+		i = (y + (_yNum * x)) * _nComponents;
+		for(v = 0; v < _nComponents; v++) {
+		    dp[v] = _values[i+v];
 		}
-		dp += extents_;
-	    }
-	}
-	delete [] values_;
-	values_ = data;
+		dp += _nComponents;
+	    }
+	}
+	delete [] _values;
+	_values = data;
     }
 #endif
-    initialized_ = true;
+    _initialized = true;
     return TCL_OK;
 }
+
+
+bool
+Rappture::Unirect3d::ReadVectorDataFromDx(Rappture::Outcome &result, 
+	size_t length, char *string) 
+{
+    size_t nx, ny, nz, npts;
+    double x0, y0, z0, dx, dy, dz, ddx, ddy, ddz;
+    char *p, *endPtr;
+
+    dx = dy = dz = 0.0;         // Suppress compiler warning.
+    x0 = y0 = z0 = 0.0;		// May not have an origin line.
+    for (p = string, endPtr = p + length; p < endPtr; /*empty*/) {
+	char *line;
+
+	line = getline(&p, endPtr);
+        if (line == endPtr) {
+	    break;
+	}
+        if ((line[0] == '#') || (line == '\0')) {
+	    continue;		// Skip blank or comment lines.
+	}
+	if (sscanf(line, "object %*d class gridpositions counts %d %d %d", 
+		   &nx, &ny, &nz) == 3) {
+	    if ((nx < 0) || (ny < 0) || (nz < 0)) {
+		result.addError("invalid grid size: x=%d, y=%d, z=%d", 
+			nx, ny, nz);
+		return false;
+	    }
+	} else if (sscanf(line, "origin %lg %lg %lg", &x0, &y0, &z0) == 3) {
+	    // found origin
+	} else if (sscanf(line, "delta %lg %lg %lg", &ddx, &ddy, &ddz) == 3) {
+	    // found one of the delta lines
+	    if (ddx != 0.0) {
+		dx = ddx;
+	    } else if (ddy != 0.0) {
+		dy = ddy;
+	    } else if (ddz != 0.0) {
+		dz = ddz;
+	    }
+	} else if (sscanf(line, "object %*d class array type %*s shape 3"
+		" rank 1 items %d data follows", &npts) == 1) {
+	    printf("#points=%d\n", npts);
+	    if (npts != nx*ny*nz) {
+		result.addError("inconsistent data: expected %d points"
+				" but found %d points", nx*ny*nz, npts);
+		return false;
+	    }
+	    break;
+	} else if (sscanf(line, "object %*d class array type %*s rank 0"
+		" times %d data follows", &npts) == 1) {
+	    if (npts != nx*ny*nz) {
+		result.addError("inconsistent data: expected %d points"
+				" but found %d points", nx*ny*nz, npts);
+		return false;
+	    }
+	    break;
+	}
+    }
+    if (npts != nx*ny*nz) {
+	result.addError("inconsistent data: expected %d points"
+			" but found %d points", nx*ny*nz, npts);
+	return false;
+    }
+
+    _initialized = false;
+    _xValueMin = _yValueMin = _zValueMin = FLT_MAX;
+    _xValueMax = _yValueMax = _zValueMax = -FLT_MAX;
+    _xMin = x0, _yMin = y0, _zMin = z0;
+    _xNum = nx, _yNum = ny, _zNum = nz;
+    _xMax = _xMin + dx * _xNum;
+    _yMax = _yMin + dy * _yNum;
+    _zMax = _zMin + dz * _zNum;
+    if (_values != NULL) {
+	delete [] _values;
+    }
+    _values = new float[npts * _nComponents];
+    _nValues = 0;
+    for (size_t ix = 0; ix < _xNum; ix++) {
+	for (size_t iy = 0; iy < _yNum; iy++) {
+	    for (size_t iz = 0; iz < _zNum; iz++) {
+		char *line;
+		if ((p == endPtr) || (_nValues > (size_t)npts)) {
+		    break;
+		}
+		line = getline(&p, endPtr);
+		if ((line[0] == '#') || (line[0] == '\0')) {
+		    continue;	// Skip blank or comment lines.
+		}
+		double vx, vy, vz;
+		if (sscanf(line, "%lg %lg %lg", &vx, &vy, &vz) == 3) {
+		    int nindex = (iz*nx*ny + iy*nx + ix) * 3;
+		    if (vx < _xValueMin) {
+			_xValueMin = vx;
+		    } else if (vx > _xValueMax) {
+			_xValueMax = vx;
+		    }
+		    if (vy < _yValueMin) {
+			_yValueMin = vy;
+		    } else if (vy > _yValueMax) {
+			_yValueMax = vy;
+		    }
+		    if (vz < _zValueMin) {
+			_zValueMin = vz;
+		    } else if (vz > _zValueMax) {
+			_zValueMax = vz;
+		    }
+		    if (nindex >= (npts*3)) {
+			fprintf(stderr, "nindex=%d, npts=%d, z=%d, y=%d, x=%d\n",
+				nindex, npts, iz, iy, ix);
+		    }
+		    _values[nindex] = vx;
+		    _values[nindex+1] = vy;
+		    _values[nindex+2] = vz;
+		    _nValues++;
+		}
+	    }
+	}
+    }
+    // make sure that we read all of the expected points
+    if (_nValues != npts) {
+	result.addError("inconsistent data: expected %d points"
+			" but found %d points", npts, _nValues);
+	delete []  _values;
+	_values = NULL;
+	return false;
+    }
+    _nValues *= _nComponents;
+    _initialized = true;
+    return true;
+}
+
+
+bool
+Rappture::Unirect3d::Resample(Rappture::Outcome &result, int nSamples)
+{
+    Rappture::Mesh1D xgrid(_xMin, _xMax, _xNum);
+    Rappture::Mesh1D ygrid(_yMin, _yMax, _yNum);
+    Rappture::Mesh1D zgrid(_zMin, _zMax, _zNum);
+    Rappture::FieldRect3D xfield(xgrid, ygrid, zgrid);
+    Rappture::FieldRect3D yfield(xgrid, ygrid, zgrid);
+    Rappture::FieldRect3D zfield(xgrid, ygrid, zgrid);
+
+    size_t i, j;
+    for (i = 0, j = 0; i < _nValues; i += _nComponents, j++) {
+	double vx, vy, vz;
+
+	vx = _values[i];
+	vy = _values[i+1];
+	vz = _values[i+2];
+	
+	xfield.define(j, vx);
+	yfield.define(j, vy);
+	zfield.define(j, vz);
+    }
+    // Figure out a good mesh spacing
+    double dx, dy, dz;
+    dx = xfield.rangeMax(Rappture::xaxis) - xfield.rangeMin(Rappture::xaxis);
+    dy = xfield.rangeMax(Rappture::yaxis) - xfield.rangeMin(Rappture::yaxis);
+    dz = xfield.rangeMax(Rappture::zaxis) - xfield.rangeMin(Rappture::zaxis);
+
+    double dmin;
+    dmin = pow((dx*dy*dz)/(nSamples*nSamples*nSamples), 0.333);
+    
+    printf("dx:%lf dy:%lf dz:%lf dmin:%lf\n", dx, dy, dz, dmin);
+
+    /* Recompute new number of points for each axis. */
+    _xNum = (size_t)ceil(dx/dmin);
+    _yNum = (size_t)ceil(dy/dmin);
+    _zNum = (size_t)ceil(dz/dmin);
+    
+#ifndef NV40
+    // must be an even power of 2 for older cards
+    _xNum = (int)pow(2.0, ceil(log10((double)_xNum)/log10(2.0)));
+    _yNum = (int)pow(2.0, ceil(log10((double)_yNum)/log10(2.0)));
+    _zNum = (int)pow(2.0, ceil(log10((double)_zNum)/log10(2.0)));
+#endif
+
+    size_t n = _nComponents * _xNum * _yNum * _zNum;
+    float *data = new float[n];
+    memset(data, 0, sizeof(float) * n);
+    
+    // Generate the uniformly sampled rectangle that we need for a volume
+    float *destPtr = data;
+    for (size_t i = 0; i < _zNum; i++) {
+	double z;
+
+	z = _zMin + (i * dmin);
+	for (size_t j = 0; j < _yNum; j++) {
+	    double y;
+		
+	    y = _yMin + (j * dmin);
+	    for (size_t k = 0; k < _xNum; k++) {
+		double x;
+
+		x = _xMin + (k * dmin);
+		destPtr[0] = xfield.value(x, y, z);
+		destPtr[1] = yfield.value(x, y, z);
+		destPtr[2] = zfield.value(x, y, z);
+	    }
+	}
+    }
+    delete [] _values;
+    _values = data;
+    _nValues = _xNum * _yNum * _zNum * _nComponents;
+    return true;
+}
+
Index: trunk/packages/vizservers/nanovis/Unirect.h
===================================================================
--- trunk/packages/vizservers/nanovis/Unirect.h	(revision 1428)
+++ trunk/packages/vizservers/nanovis/Unirect.h	(revision 1429)
@@ -7,20 +7,18 @@
 
 class Unirect3d {
-    size_t xNum_, yNum_, zNum_;
-    size_t nValues_;
-    int extents_;
-
-    float xMin_, xMax_;
-    float yMin_, yMax_;
-    float zMin_, zMax_;
-    float vMin_, vMax_;
-
-    char *xUnits_;
-    char *yUnits_;
-    char *zUnits_;
-    char *vUnits_;
-
-    float *values_;
-    bool initialized_;
+    size_t _xNum, _yNum, _zNum;
+    size_t _nValues;
+    size_t _nComponents;
+    float _xMin, _xMax, _yMin, _yMax, _zMin, _zMax;
+    float _xValueMin, _xValueMax;
+    float _yValueMin, _yValueMax;
+    float _zValueMin, _zValueMax;
+    char *_xUnits;
+    char *_yUnits;
+    char *_zUnits;
+    char *_vUnits;
+
+    float *_values;
+    bool _initialized;
 
 public:
@@ -28,197 +26,222 @@
 	      float yMin, float yMax, size_t yNum, 
 	      float zMin, float zMax, size_t zNum, 
-	      size_t nValues, float *values) {
-	xMax_ = xMax;
-	xMin_ = xMin;
-	xNum_ = xNum;
-	yMax_ = yMax;
-	yMin_ = yMin;
-	yNum_ = yNum;
-	zMax_ = zMax;
-	zMin_ = zMin;
-	zNum_ = zNum;
-	nValues_ = nValues;
-	values_ = values;
-	initialized_ = true;
-    }
-
-    Unirect3d(void) {
-	values_ = NULL;
-	initialized_ = false;
-	xNum_ = yNum_ = zNum_ = 0;
-	nValues_ = 0;
-	xUnits_ = yUnits_ = zUnits_ = vUnits_ = NULL;
+	      size_t nValues, float *values, size_t nComponents) 
+    {
+	SetValues(xMin, xMax, xNum, yMin, yMax, yNum, zMin, zMax, zNum, 
+		  nValues, values, nComponents);
+    }
+
+    Unirect3d(size_t nComponents = 1) {
+	_values = NULL;
+	_initialized = false;
+	_xNum = _yNum = _zNum = 0;
+	_nValues = 0;
+	_xUnits = _yUnits = _zUnits = _vUnits = NULL;
+	_nComponents = nComponents;
     }
     ~Unirect3d(void) {
-	if (values_ != NULL) {
-	    delete [] values_;
-	}
-	if (xUnits_ != NULL) {
-	    free(xUnits_);
-	}
-	if (yUnits_ != NULL) {
-	    free(yUnits_);
-	}
-	if (zUnits_ != NULL) {
-	    free(zUnits_);
-	}
-	if (vUnits_ != NULL) {
-	    free(vUnits_);
-	}
+	if (_values != NULL) {
+	    delete [] _values;
+	}
+	if (_xUnits != NULL) {
+	    free(_xUnits);
+	}
+	if (_yUnits != NULL) {
+	    free(_yUnits);
+	}
+	if (_zUnits != NULL) {
+	    free(_zUnits);
+	}
+	if (_vUnits != NULL) {
+	    free(_vUnits);
+	}
+    }
+    void SetValues(float xMin, float xMax, size_t xNum, 
+		   float yMin, float yMax, size_t yNum, 
+		   float zMin, float zMax, size_t zNum, 
+		   size_t nValues, float *values, size_t nComponents) {
+	_xMax = xMax;
+	_xMin = xMin;
+	_xNum = xNum;
+	_yMax = yMax;
+	_yMin = yMin;
+	_yNum = yNum;
+	_zMax = zMax;
+	_zMin = zMin;
+	_zNum = zNum;
+	_nValues = nValues;
+	_values = values;
+	_initialized = true;
+	_nComponents = nComponents;
     }
     size_t xNum(void) {
-	return xNum_;
+	return _xNum;
     }
     size_t yNum(void) {
-	return yNum_;
+	return _yNum;
     }
     size_t zNum(void) {
-	return zNum_;
+	return _zNum;
     }
     float xMin(void) {
-	return xMin_;
+	return _xMin;
     }
     float yMin(void) {
-	return yMin_;
+	return _yMin;
     }
     float zMin(void) {
-	return zMin_;
+	return _zMin;
     }
     float xMax(void) {
-	return xMax_;
+	return _xMax;
     }
     float yMax(void) {
-	return yMax_;
+	return _yMax;
     }
     float zMax(void) {
-	return zMax_;
+	return _zMax;
+    }
+    float xValueMin(void) {
+	return _xValueMin;
+    }
+    float yValueMin(void) {
+	return _yValueMin;
+    }
+    float zValueMin(void) {
+	return _zValueMin;
+    }
+    float xValueMax(void) {
+	return _xValueMax;
+    }
+    float yValueMax(void) {
+	return _yValueMax;
+    }
+    float zValueMax(void) {
+	return _zValueMax;
+    }
+    size_t nComponents(void) {
+	return _nComponents;
     }
     const char *xUnits(void) {
-	return xUnits_;
+	return _xUnits;
     }
     const char *yUnits(void) {
-	return yUnits_;
+	return _yUnits;
     }
     const char *zUnits(void) {
-	return zUnits_;
+	return _zUnits;
     }
     const char *vUnits(void) {
-	return vUnits_;
+	return _vUnits;
+    }
+    const float *values(void) {
+	return _values;
+    }
+    const float *SaveValues(void) {
+	float *values;
+	values = _values;
+	_values = NULL;
+	_nValues = 0;
+	return values;
+    }
+    size_t nValues(void) {
+	return _nValues;
+    }
+    int LoadData(Tcl_Interp *interp, int objc, Tcl_Obj *const *objv);
+
+    bool ReadVectorDataFromDx(Rappture::Outcome &result, size_t length, 
+	char *string);
+    bool Resample(Rappture::Outcome &context, int nSamples = 30);
+    bool isInitialized(void) {
+	return _initialized;
+    }
+};
+
+class Unirect2d {
+    size_t _xNum, _yNum;
+    size_t _nValues;
+    size_t _nComponents;
+
+    float _xMin, _xMax;
+    float _yMin, _yMax;
+    float _xValueMin, _xValueMax;
+    float _yValueMin, _yValueMax;
+
+    char *_xUnits;
+    char *_yUnits;
+    char *_vUnits;
+
+    float *_values;
+    bool _initialized;
+
+public:
+    Unirect2d(size_t nComponents = 1) {
+	_values = NULL;
+	_initialized = false;
+	_xNum = _yNum = 0;
+	_nValues = 0;
+	_xUnits = _yUnits = _vUnits = NULL;
+	_nComponents = nComponents;
+    }
+    ~Unirect2d(void) {
+	if (_values != NULL) {
+	    delete [] _values;
+	}
+	if (_xUnits != NULL) {
+	    free(_xUnits);
+	}
+	if (_yUnits != NULL) {
+	    free(_yUnits);
+	}
+	if (_vUnits != NULL) {
+	    free(_vUnits);
+	}
+    }
+    size_t xNum(void) {
+	return _xNum;
+    }
+    size_t yNum(void) {
+	return _yNum;
+    }
+    float xMin(void) {
+	return _xMin;
+    }
+    float yMin(void) {
+	return _yMin;
+    }
+    float xMax(void) {
+	return _xMax;
+    }
+    float yMax(void) {
+	return _yMax;
+    }
+    const char *xUnits(void) {
+	return _xUnits;
+    }
+    const char *yUnits(void) {
+	return _yUnits;
+    }
+    const char *vUnits(void) {
+	return _vUnits;
     }
     float *values(void) {
-	return values_;
-    }
-    float *SaveValues(void) {
+	return _values;
+    }
+    float *acceptValues(void) {
 	float *values;
-	values = values_;
-	values_ = NULL;
-	nValues_ = 0;
+	values = _values;
+	_values = NULL;
+	_nValues = 0;
 	return values;
     }
     size_t nValues(void) {
-	return nValues_;
-    }
-    size_t extents(void) {
-	return extents_;
-    }
-    void extents(size_t extents) {
-	extents_ = extents;
+	return _nValues;
     }
     int LoadData(Tcl_Interp *interp, int objc, Tcl_Obj *const *objv);
     bool isInitialized(void) {
-	return initialized_;
+	return _initialized;
     }
 };
 
-class Unirect2d {
-    size_t xNum_, yNum_;
-    size_t nValues_;
-    size_t extents_;
-
-    float xMin_, xMax_;
-    float yMin_, yMax_;
-    float vMin_, vMax_;
-
-    char *xUnits_;
-    char *yUnits_;
-    char *vUnits_;
-
-    float *values_;
-    bool initialized_;
-
-public:
-    Unirect2d(void) {
-	values_ = NULL;
-	initialized_ = false;
-	xNum_ = yNum_ = 0;
-	nValues_ = 0;
-	xUnits_ = yUnits_ = vUnits_ = NULL;
-    }
-    ~Unirect2d(void) {
-	if (values_ != NULL) {
-	    delete [] values_;
-	}
-	if (xUnits_ != NULL) {
-	    free(xUnits_);
-	}
-	if (yUnits_ != NULL) {
-	    free(yUnits_);
-	}
-	if (vUnits_ != NULL) {
-	    free(vUnits_);
-	}
-    }
-    size_t xNum(void) {
-	return xNum_;
-    }
-    size_t yNum(void) {
-	return yNum_;
-    }
-    float xMin(void) {
-	return xMin_;
-    }
-    float yMin(void) {
-	return yMin_;
-    }
-    float xMax(void) {
-	return xMax_;
-    }
-    float yMax(void) {
-	return yMax_;
-    }
-    const char *xUnits(void) {
-	return xUnits_;
-    }
-    const char *yUnits(void) {
-	return yUnits_;
-    }
-    const char *vUnits(void) {
-	return vUnits_;
-    }
-    float *values(void) {
-	return values_;
-    }
-    float *acceptValues(void) {
-	float *values;
-	values = values_;
-	values_ = NULL;
-	nValues_ = 0;
-	return values;
-    }
-    size_t nValues(void) {
-	return nValues_;
-    }
-    size_t extents(void) {
-	return extents_;
-    }
-    void extents(size_t extents) {
-	extents_ = extents;
-    }
-    int LoadData(Tcl_Interp *interp, int objc, Tcl_Obj *const *objv);
-    bool isInitialized(void) {
-	return initialized_;
-    }
-};
-
 }
 
Index: trunk/packages/vizservers/nanovis/Volume.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/Volume.cpp	(revision 1428)
+++ trunk/packages/vizservers/nanovis/Volume.cpp	(revision 1429)
@@ -49,5 +49,5 @@
     int fcount = width * height * depth * n_components;
     _data = new float[fcount];
-    if (data) {
+    if (data != NULL) {
         Trace("data is copied\n");
         memcpy(_data, data, fcount * sizeof(float));
